﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;


namespace Plugin_Code_Repetition
{

    // Adjust configuration of Code using repetition scheme
    public partial class Configure : Window
    {

        private Plugin_Code_Repetition Plugin;

        public Configure(Plugin_Code_Repetition plugin)
        {
            Plugin = plugin;
            InitializeComponent();

            // Set window componenets to display current values.
            txtRepetition.Text = plugin.RepeatTimes.ToString();
            cbSoftDecode.IsChecked = plugin.SoftDecode;
        }

        // Validate, Save, Close.
        private void btnOK_Click(object sender, RoutedEventArgs e)
        {
            var succ = false;

            // Validate number of times a bit repeats
            int repeat;
            succ = Int32.TryParse(txtRepetition.Text, out repeat);
            if( !succ || repeat <= 0 )
            {
                System.Windows.MessageBox.Show( "Repetition count should be a positive integer > 0" );
                return;
            }

            // Save configuration
            Plugin.RepeatTimes = repeat;
            Plugin.SoftDecode = cbSoftDecode.IsChecked ?? false;

            this.Close();
        }


    }
}
