﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;

namespace Plugin_DataSource_Exhaustive
{
    
    // Adjust configuration of DataSource using all possible values of given length
    public partial class Configure : Window
    {
        
        private Plugin_DataSource_Exhaustive Plugin_DataSource_Exhaustive;

        public Configure( Plugin_DataSource_Exhaustive pluginDS )
        {
            Plugin_DataSource_Exhaustive = pluginDS;
            InitializeComponent();

            // Set window componenets to display current values.
            var plugin = Plugin_DataSource_Exhaustive;
            txtAlignment.Text = plugin.Alignment.ToString();
            txtLengthMin.Text = plugin.LengthMin.ToString();
            txtLengthMax.Text = plugin.LengthMax.ToString();
            
        }

        // Validate, Save, Close.
        private void btnOK_Click(object sender, RoutedEventArgs e)
        {
            var succ = false;

            // Validate sample length alignment/divisibility
            int alignment;
            succ = Int32.TryParse(txtAlignment.Text, out alignment);
            if( !succ || alignment <= 0 )
            {
                System.Windows.MessageBox.Show( "Alignment should be a positive integer > 0" );
                return;
            }

            // Validate sample minimum/initial length
            int lengthMin;
            succ = Int32.TryParse(txtLengthMin.Text, out lengthMin);
            if( !succ || lengthMin <= 0 )
            {
                System.Windows.MessageBox.Show( "Minimum length should be a positive integer > 0" );
                return;
            }

            // Validate sample maximum length
            int lengthMax;
            succ = Int32.TryParse(txtLengthMax.Text, out lengthMax);
            if( !succ || lengthMax < 0 )
            {
                System.Windows.MessageBox.Show( "Maximum length should be a positive integer" );
                return;
            }

            // Validate ratio of min and max sample length
            if( lengthMin > lengthMax )
            {
                System.Windows.MessageBox.Show( "Maximum length should greater than minimum length" );
                return;
            }

            // Save configuration
            var plugin = Plugin_DataSource_Exhaustive;
            plugin.Alignment = alignment;
            plugin.LengthMin = lengthMin;
            plugin.LengthMax = lengthMax;
            
            this.Close();
        }


    }
}
