﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Plugin_SDK;
using System.Collections;


namespace CodeChannelTester
{
    /// <summary>
    /// Interface for DataSource plugin objects.
    /// A DataSource is responsible for enumerating a set of finite length signals that will
    /// be used to evaluate the code across a channel.
    /// </summary>
    abstract public class DataSource : Plugin_Configurable
    {

        // Retreives the next signal / data sample to be encoded and transmitted.
        // If no further data samples are available, the returned value will be null.
        public abstract BitArray GetNextBurst();

    }
}
